/*
*  Rubrica
*  file: prefer-configure.h
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_PREFERENCES_CONFIGURE_H
#define __RUBRICA_PREFERENCES_CONFIGURE_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <gconf/gconf-client.h>

#include "prefer.h"

/*  Setting funcions:
    when the preferences window dialog is called, 
    widgets are filled with values stored in changeset
*/
void rubrica_preferences_configure_check(GtkWidget *check, 
					 GConfClient *client, 
					 gchar *key);

void rubrica_preferences_configure_radio(GtkWidget *radio1, 
					 GtkWidget *radio2,
					 GConfClient *client, 
					 gchar *key1,
					 gchar *key2);


void rubrica_preferences_configure_check_radio(GtkWidget *check, 
					       GtkWidget *radio1, 
					       GtkWidget *radio2,
					       GConfClient *client, 
					       gchar *checkkey,
					       gchar *radio1key);

void rubrica_preferences_configure_spin(GtkWidget *check,
					GtkWidget *spin,
					GConfClient *client, 
					gchar *key1,
					gchar *key2);

void rubrica_preferences_configure_entry(GtkWidget *entry, 
					 GConfClient *client, 
					 gchar *key);

void rubrica_preferences_configure_label(GtkWidget *label, 
					 GConfClient *client, 
					 gchar *key);

void rubrica_preferences_configure_checked_entry(GtkWidget *check,
						 GtkWidget *gnome_entry,
						 GtkWidget *entry, 
						 GConfClient *client, 
						 gchar *key1, 
						 gchar *key2);

void rubrica_preferences_configure_combo_entry(GtkWidget *entry, 
					       GConfClient *client, 
					       gchar *key);

void 
rubrica_preferences_configure_radio_dictionary(GtkWidget *radio1, 
					       GtkWidget *radio2,
					       GConfClient *client, 
					       gchar *key1,
					       gchar *key2);

void rubrica_preferences_display_messages(gchar *str);
void rubrica_preferences_reset_errors(void);
gchar **rubrica_preferences_get_buffer_error(void);
gboolean rubrica_preferences_there_are_errors(void);

#endif
