#include <gnome.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

gchar buf[128];
gboolean log_enabled = TRUE;
gchar *log_file = NULL;
FILE  *log = NULL;

void rubrica_log_init_log_file(void)
{
  time_t curtime; 
  struct tm *loctime; 

  if (!log_enabled)
    return;

  g_print("\nRubrica: opening log file..."); 

  curtime = time(NULL); 
  loctime = localtime(&curtime);
  strftime(buf, 128, "\nRubrica starting: %A %B %Y\t%I:%M", loctime); 

  log_file = g_strdup_printf("/%s/.rubrica/rubrica.log", g_get_home_dir());

  log = fopen(log_file, "a+");

  if(log == NULL)
    { 
      g_print("\nRubrica: can't open log file (file pointer: %p)", log); 
    } 
  else 
    {  
      fprintf (log, "%s", buf);  
      fflush(log);
    } 

  g_print("\nRubrica: log file opened."); 
} 


void rubrica_log_write_log(gchar *str)
{
  if (!log_enabled)
    return;

  fprintf(log, "%s", str);  
  fflush(log);
}


void rubrica_log_close_log_file(void)
{
  time_t curtime; 
  struct tm *loctime; 

  if (!log_enabled)
    return;

  curtime = time(NULL); 
  loctime = localtime(&curtime);
  strftime(buf, 128, "\nRubrica closed: %A %B %Y\t%I:%M", loctime);

  fprintf (log, "%s\n\n", buf);  
  
  fflush(log);
  fclose(log);
}
